import React from 'react';

export interface IPropsPagination  {
   total: number; // total de páginas
   perPage: number; // items por página
   currentPage: number; // págiona atual
   onChange: (page: number) => void; // callback ao mudar de página
   activeTextColor?: string; // cor do texto ativo
   activeBgColor?: string; // cor do fundo ativo
   textColor?: string; // cor do texto
}
