export interface IPropsDatepicker {
    name?: any;
    nameAllDay?: string;
    title?: string;
    applyOnSelect?: boolean;
    value?: Date;
    onValueChange?: (value: Date, formatted: string) => void;
    allDay?: boolean;
    onAllDayChange?: (value: boolean) => void;
    withTimePicker?: boolean;
    error?: string;
    asPopup?: boolean;
    children?: any;
    formattedString?: string;
    enableAllDay?: boolean;
    disablePastDates?: boolean;
    formatShowDate?: string;
    formatTimeDate?: string;
    TimerPickerPlusComponent?: JSX.Element;
    TimerPickerMinusComponent?: JSX.Element;
}
export interface IValueDatePicker {
    day: number;
    month: number;
    year: number;
    today: boolean;
    date: string;
    dateYYYYMMDD: string;
    allDay: boolean;
    hour: string;
    minutes: string;
}
export declare type IInputDatePicker = {
    dateYYYYMMDD?: string;
    dateYYYYMMDDhhiiss?: string;
    date: Date;
    day?: number;
    year?: number;
    month?: number;
    hour?: number;
    minutes?: number;
    isToday?: boolean;
    allDay?: boolean;
} | null;
//# sourceMappingURL=Datepicker.interface.d.ts.map