import React from 'react';

export interface ITab {
   id: string | number;
   name: string | JSX.Element;
   active?: boolean;
}

export interface IPropsTabs  {
   options: ITab[];
   activeButtonRounded?: boolean;
   onSelect: (tab: ITab) => void;
   disabled?: boolean;
   skeleton?: boolean;
   defaultTab?: string | number;
   backgroundActiveColor?: string;
   textActiveColor?: string;
   textColor?: string;
}

export interface ITabsRef {
   setTab: (tab: string | number) => void;
}
